# Введение

**Документ содержит** инструкции по установке и настройке {{ serviceName }}.

{{ serviceName }} — это набор сервисов и утилит, предоставляющих возможность управлять серверами Яндекса, в том числе удаленно запускать команды и эффективно копировать каталоги и файлы на группе серверов.

В документе перечислены поддерживаемые операционные системы серверов, приведены инструкции по конфигурации {{ serviceName }} (выполняется в сервисе [Genisys](https://genisys.yandex-team.ru)), рассмотрен порядок установки {{ serviceName }} на серверах.

**Целевая аудитория документа** — администраторы и разработчики, использующие и планирующие внедрение {{ serviceName }}.

**Документ не содержит** описания архитектуры {{ serviceName }} и всех процедур, которые могут выполняться в сервисе {{ deploy-and-configService }}.

## Структура документа

1. [Общие сведения](basic-info.md): назначение и список ключевых возможностей {{ serviceName }}.
1. [Поддерживаемые ОС](restrictions.md): список операционных систем, на которых может быть установлен {{ serviceName }}.
1. [Установка и настройка](installation.md): описание последовательности действий, требуемых для установки {{ serviceName }} на группу серверов.
1. [Серверные доступы](access.md): сведения о доступах, необходимых для работы {{ serviceName }}.
1. [Параметры установки и функционирования](configuration.md): описание процедур, в рамках которых определяются версия и набор сервисов {{ serviceName }} для установки на группу серверов. Процедуры выполняются в сервисе {{ deploy-and-configService }}.
1. [Утилита gosky](gosky-install.md): информация об утилите gosky, которая используется для взаимодействия группы серверов с сервисами {{ deploy-and-configService }} и Sandbox.

Информация о версиях документа приведена в разделе [Релизы](releases.md).

### Узнайте больше

* [Skynet. Общее описание](https://doc.yandex-team.ru/Search/skynet-desc/concepts/about.html#about)
