# Введение

**Документ содержит** общие сведения о {{ serviceName }} — наборе сервисов, предоставляющих возможность управлять серверами Яндекса, в том числе — удаленно запускать команды и эффективно копировать каталоги и файлы на группе серверов.

В документе рассмотрено назначение {{ serviceName }}, приведена информация об установке и основных сервисах, описаны принципы аутентификации и перечислены доступные интерфейсы к возможностям {{ serviceName }}.

**Целевая аудитория документа** — разработчики и менеджеры сервисов, использующих и планирующих внедрение {{ serviceName }}.

**Документ не содержит** подробных сведений об установке, информации об использовании
 программных интерфейсов.

## Структура документа

1. [Общие сведения](basic-info.md): назначение и ключевые возможности {{ serviceName }}.
1. [Установка](installation.md): обзор процедуры установки {{ serviceName }}.
1. [Публичные сервисы](public/public-services.md): краткое описание сервисов {{ serviceName }}, доступ к которым предоставляется по API.
1. [Внутренние сервисы](internal/internal-services.md): общая информация об основных сервисах и интерфейсах, обеспечивающих взаимодействие различных компонентов {{ serviceName }}, в том числе — с внешними системами.
1. [Аутентификация](authentication.md): принципы разграничения прав доступа.
1. [Программные интерфейсы](api-list.md): список API, предоставляемых для доступа к возможностям {{ serviceName }}.

Информация о версиях документа приведена в разделе [Релизы](releases.md).

### Узнайте больше
- [Skynet. Руководство по установке и настройке](https://doc.yandex-team.ru/Search/skynet-ag/concepts/about.html#about)
- [Sky. Справочник администратора](https://doc.yandex-team.ru/Search/skynet-dg/concepts/about.html#about)
- [Skynet. Python API](https://doc.yandex-team.ru/Search/skynet-api/cqueue/index.html)