PY23_LIBRARY()

OWNER(g:skynet)

PEERDIR(
    contrib/python/msgpack
    contrib/python/setuptools
    contrib/python/PyYAML
)

IF (NOT OS_WINDOWS)
    PEERDIR(
        contrib/python/setproctitle
    )
ENDIF()

NO_CHECK_IMPORTS(
    kernel.*
)

PY_SRCS(
    NAMESPACE kernel

    util/misc.py
    util/pickle.py
    util/tests/test_greenlet.py
    util/tests/test_functional.py
    util/tests/test_stream.py
    util/tests/test_errors.py
    util/tests/test_config.py
    util/tests/test_mtitertools.py
    util/tests/test_pickle.py
    util/tests/__init__.py
    util/logging.py
    util/unittest.py
    util/sys/dirut.py
    util/sys/winsymlink.py
    util/sys/tests/test_getpeerid.py
    util/sys/tests/test_aio.py
    util/sys/tests/test_pipenblock.py
    util/sys/syslibs.py
    util/sys/pam.py
    util/sys/pipenblock.py
    util/sys/getpeerid/linux.py
    util/sys/getpeerid/darwin.py
    util/sys/getpeerid/freebsd.py
    util/sys/getpeerid/__init__.py
    util/sys/user/posix.py
    util/sys/user/_freebsd.py
    util/sys/user/_darwin.py
    util/sys/user/_linux.py
    util/sys/user/__init__.py
    util/sys/user/windows.py
    util/sys/atexit.py
    util/sys/gettime.py
    util/sys/ncpu.py
    util/sys/affinity.py
    util/sys/daemonize.py
    util/sys/aio.py
    util/sys/__init__.py
    util/math.py
    util/gevent/monkey.py
    util/gevent/deblock.py
    util/gevent/linkable.py
    util/gevent/event.py
    util/gevent/timeout.py
    util/gevent/threadsafe.py
    util/gevent/pool.py
    util/gevent/greenlet.py
    util/gevent/__init__.py
    util/uuid.py
    util/base/metabase.py
    util/base/__init__.py
    util/functional.py
    util/mtitertools.py
    util/log/log.py
    util/log/loginstaller.py
    util/log/__init__.py
    util/priorities.py
    util/errors.py
    util/collections/cidict.py
    util/collections/cistr.py
    util/collections/__init__.py
    util/proc/__init__.py
    util/streams/zstream.py
    util/streams/streambase.py
    util/streams/__init__.py
    util/threads.py
    util/net/misc.py
    util/net/getifaddrs.py
    util/net/dns.py
    util/net/tests/test_getifaddres.py
    util/net/tests/test_socketserver.py
    util/net/tests/test_misc.py
    util/net/tests/test_dns.py
    util/net/socketpair.py
    util/net/socketserver.py
    util/net/socketstream.py
    util/net/uriloader.py
    util/net/pipestream.py
    util/net/pipe.py
    util/net/__init__.py
    util/objproxy.py
    util/config.py
    util/beta.py
    util/utils.py
    util/pytest.py
    util/__init__.py
    util/console/setproctitle.py
    util/console/colors.py
    util/console/__init__.py
    xmlrpc/MultiMarshallerXMLRPCServer.py
    xmlrpc/GreenletMixIn.py
    xmlrpc/test_proxy.py
    xmlrpc/proxy.py
    xmlrpc/__init__.py
    config.py
    __init__.py
)

IF(PYTHON2)
    PY_SRCS(
        NAMESPACE kernel
        pyro/misc.py
        pyro/server.py
        pyro/errors.py
        pyro/stop.py
        pyro/client.py
        pyro/__init__.py
        zeromq/context.py
        zeromq/server.py
        zeromq/errors.py
        zeromq/async.py
        zeromq/stop.py
        zeromq/fixpath.py
        zeromq/client.py
        zeromq/nointr.py
        zeromq/__init__.py
    )
ENDIF()

END()
