class VersionRunner(object):
    def run(self):
        import sys
        import os

        from pkg_resources import require
        require('pyyaml')

        import yaml

        _ = os.path.realpath(sys.executable)
        for i in range(3):
            _ = os.path.dirname(_)
        basepath = _

        infopath = os.path.join(basepath, '.info')

        try:
            info = yaml.load(open(infopath, 'rb'))
            pathhack = False
        except yaml.constructor.ConstructorError:
            class Path(str):
                strpath = str
            for name in '__new__main__', '__remote_main__':
                if name in sys.modules:
                    sys.modules[name].Path = Path
            info = yaml.load(open(infopath, 'rb'))
            pathhack = True

        itms = [(None, None, info)]

        while itms:
            item = itms.pop(0)

            if isinstance(item[2], (list, tuple)):
                for idx, sub in enumerate(item[2]):
                    itms.append((item[2], idx, sub))

                continue

            elif isinstance(item[2], dict):
                for key, sub in item[2].items():
                    itms.append((item[2], key, sub))

                continue

            elif pathhack and isinstance(item[2], Path):
                if item[0] is not None:
                    item[0][item[1]] = item[2].strpath

        return info
